UNIT Y360x480;


INTERFACE


VAR r,v,b:BYTE;


PROCEDURE YRemplitEcran(couleur:BYTE);
PROCEDURE YMode360x480; {Physique=360x480 - Virtuel=360x727}
PROCEDURE YModeTexte;
PROCEDURE YAttenteSynchro;
PROCEDURE YEcritPoint(x,y:WORD;couleur:BYTE);
FUNCTION  YLitPoint(x,y:WORD):BYTE;
PROCEDURE YScroll(y:WORD);
PROCEDURE YSplit(ligne:WORD);
PROCEDURE YLigneH(x,y,x2:word;couleur:byte);
PROCEDURE YLigneV(x,y,y2:word;couleur:byte);
PROCEDURE YEcritCouleur(couleur,r,v,b:BYTE);
PROCEDURE YLitCouleur(couleur:BYTE);
PROCEDURE YEcritPalette(VAR palette;debut,quantite:WORD);


IMPLEMENTATION


PROCEDURE YRemplitEcran(couleur:BYTE);ASSEMBLER;
ASM
  mov   ax, 0A000h
  mov   es, ax
  mov   dx, 3C4h
  mov   ax, 0F02h
  out   dx, ax
  xor   di, di
  mov   cx, 8000h
  cld
  mov   al, couleur;
  mov   ah, al
  repz  stosw
END;


PROCEDURE YMode360x480;ASSEMBLER;
ASM
  mov   ax, 013h
  int   10h
  mov   dx, 03C4h
  mov   ax, 0604h
  out   dx, ax
  mov   ax, 0F02h
  out   dx, ax
  mov   dx, 03C2h
  mov   ax, 0E7h
  out   dx, ax
  mov   dx, 03D4h
  mov   ax, 011h
  out   dx, ax
  inc   dx
  in    al, dx
  and   al, 7Fh
  dec   dx
  mov   cx, ax
  mov   ax, 011h
  out   dx, ax
  inc   dx
  mov   cx, ax
  out   dx, ax
  dec   dx
  {Les 17 registres CRTC du mode 360x480}
  mov   ax, 6B00h
  out   dx, ax
  mov   ax, 5901h
  out   dx, ax
  mov   ax, 5A02h
  out   dx, ax
  mov   ax, 8E03h
  out   dx, ax
  mov   ax, 5E04h
  out   dx, ax
  mov   ax, 8A05h
  out   dx, ax
  mov   ax, 0D06h
  out   dx, ax
  mov   ax, 3E07h
  out   dx, ax
  mov   ax, 4009h
  out   dx, ax
  mov   ax, 0EA10h
  out   dx, ax
  mov   ax, 0DF12h
  out   dx, ax
  mov   ax, 2D13h
  out   dx, ax
  mov   ax, 0014h
  out   dx, ax
  mov   ax, 0E715h
  out   dx, ax
  mov   ax, 0616h
  out   dx, ax
  mov   ax, 0E317h
  out   dx, ax
  mov   ax, 0AC11h
  out   dx, ax
END;


PROCEDURE YModeTexte;ASSEMBLER;
ASM
  mov   ax, 03h
  int   10h
END;


PROCEDURE YAttenteSynchro;ASSEMBLER;
ASM
  mov   dx, 03DAh
 @L1:
  in    al, dx
  test  al, 8
  jnz   @L1
 @L2:
  in    al, dx
  test  al, 8
  jz    @L2
END;


PROCEDURE YScroll(y:WORD);ASSEMBLER;
ASM
  mov   ax, 90
  mul   y
  xor   bx, bx
  xor   cl, cl
  add   bx, ax
  mov   dx, 3D4h
  mov   al, 0Dh
  mov   ah, bl
  out   dx, ax
  dec   al
  mov   ah, bh
  out   dx, ax
  mov   dx, 03C0h
  mov   al, 33h
  out   dx, al
  and   cl, 3
  mov   al, cl
  shl   al, 1
  out   dx, al
END;


PROCEDURE YSplit(ligne:WORD);ASSEMBLER;
ASM
  push  ds
  mov   dx, 3D4h
  mov   ax, ligne
  mov   bh, ah
  mov   bl, bh
  and   bx, 0201h
  mov   cl, 4
  shl   bx, cl
  shl   bh, 1
  mov   ah, al
  mov   al, 18h
  out   dx, ax
  mov   al, 7
  out   dx, ax
  inc   dl
  in    al, dx
  dec   dl
  mov   ah, al
  and   ah, 11101111b
  or    ah, bl
  mov   al, 7
  out   dx, ax
  mov   al, 9
  out   dx, al
  inc   dl
  in    al, dx
  dec   dl
  mov   ah, al
  and   ah, 10111111b
  or    ah, bh
  mov   al, 9
  out   dx, ax
  pop   ds
END;


PROCEDURE YEcritPoint(x,y:WORD;couleur:BYTE);ASSEMBLER;
ASM
  mov   ax, 0A000h
  mov   es, ax
  mov   di, x
  mov   cx, di
  shr   di, 2
  mov   ax, 90
  mul   y;
  add   di, ax
  mov   ax, 0102h
  and   cl, 3
  shl   ah, cl
  mov   dx, 03C4h
  out   dx, ax
  mov   al, couleur
  stosb
END;


FUNCTION YLitPoint(x,y:WORD):BYTE;ASSEMBLER;
ASM
  mov   ax, 0A000h
  mov   es, ax
  mov   di, x
  mov   cx, di
  shr   di, 2
  mov   ax, 90
  mul   y
  add   di, ax
  and   cl, 3
  mov   ah, cl
  mov   al, 4
  mov   dx, 03CEh
  out   dx, ax
  mov   al, es:[di]
END;


PROCEDURE YLigneH(x,y,x2:WORD;couleur:BYTE);ASSEMBLER;
ASM
  mov   ax, 0A000h
  mov   es, ax
  cld
  mov   ax, 90
  mul   y
  mov   di, ax
  mov   bx, x
  mov   cl, bl
  shr   bx, 2
  mov   dx, x2
  mov   ch, dl
  shr   dx, 2
  and   cx, 0303h
  sub   dx, bx
  add   di, bx
  mov   ax, 0FF02h
  shl   ah, cl
  and   ah, 0Fh
  mov   cl, ch
  mov   bh, 0F1h
  rol   bh, cl
  and   bh, 0Fh
  mov   cx, dx
  or    cx, cx
  jnz   @LEFT
  and   ah, bh
 @LEFT:
  mov   dx, 03C4h
  out   dx, ax
  inc   dx
  mov   al, couleur
  stosb
  jcxz  @EXIT
  dec   cx
  jcxz  @RIGHT
  mov   al, 0Fh
  out   dx, al
  mov   al, couleur
  repz  stosb
 @RIGHT:
  mov   al, bh
  out   dx, al
  mov   al, couleur
  stosb
 @EXIT:
END;


PROCEDURE YLigneV(x,y,y2:WORD;couleur:BYTE);ASSEMBLER;
ASM
  mov   ax, 0A000h
  mov   es, ax
  cld
  mov   di, x
  mov   cx, di
  shr   di, 2
  mov   ax, 90
  mul   y
  add   di, ax
  mov   ax, 0102h
  and   cl, 3
  shl   ah, cl
  mov   dx, 03C4h
  out   dx, ax
  mov   cx, y2
  sub   cx, y
  inc   cx
  mov   al, couleur
 @DOLINE:
  mov   bl, es:[di]
  stosb
  add   di, 90-1
  loop  @DOLINE
END;


PROCEDURE YEcritCouleur(couleur,r,v,b:BYTE);ASSEMBLER;
ASM
  mov   dx, 3C8h
  mov   al, couleur
  out   dx, al
  inc   dx
  mov   al, r
  out   dx, al
  mov   al, v
  out   dx, al
  mov   al, b
  out   dx, al
END;


PROCEDURE YLitCouleur(couleur:BYTE);ASSEMBLER;
ASM
  mov   dx, 3C7h
  mov   al, couleur
  out   dx, al
  add   dx, 2
  cld
  xor   bh, bh
  in    al, dx
  mov   r , al
  in    al, dx
  mov   v , al
  in    al, dx
  mov   b , al
END;


PROCEDURE YEcritPalette(VAR palette;debut,quantite:WORD);
BEGIN
 ASM
  push  ds
  lds   si, palette
  mov   dx, 3C8h
  cld
  mov   cx, quantite
  mov   bx, debut
 @L1:
  mov   al, bl
  out   dx, al
  inc   dx
  lodsb
  out   dx, al
  lodsb
  out   dx, al
  lodsb
  out   dx, al
  dec   dx
  inc   bl
  loop  @L1
  pop   ds
 END;
END;


END.
